{ 2005-03-20 programmeerimisvistlus                                        }
{ lesanne: SNADE LAHUTAMINE                                               }
{ Autor: Avo Muromgi                                                       }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ sna sirgjooneline variantide lbivaatus }

const
 INPUT_FILE = 'sona.sis';
 OUTPUT_FILE = 'sona.val';
 MAX_N = 30;
 MAX_LENGTH = 250;

type
 TWord = record
    c : array ['A'..'Z'] of integer;
    l : integer;
end;

function StrToTWord(const s : string) : TWord;
var
 ch : char;
 i : integer;
 result : TWord;
begin
    for ch := 'A' to 'Z' do
        result.c[ch] := 0;
    result.l := length(s);
    for i := 1 to result.l do
        Inc(result.c[s[i]]);
    StrToTWord := result;
end;

var
 inf, outf : text;
 n : integer;
 lengthC : integer;
 words, stack : array [0..MAX_N] of TWord;

procedure ReadInput();
var
 i : integer;
 s : string;
begin
    Assign(inf, INPUT_FILE); Reset(inf);
    Readln(inf, s);
    words[0] := StrToTWord(s);
    Readln(inf, n);
    for i := 1 to n do begin
        Readln(inf, s);
        words[i] := StrToTWord(s);
    end;
    Close(inf);
end;

function take(const d : integer) : boolean;
var ch : char;
begin
    take := false;
    for ch := 'A' to 'Z' do begin
        Inc(stack[d].c[ch], words[d].c[ch]);
        if stack[d].c[ch] > words[0].c[ch] then
            exit;
    end;
    stack[d].l := stack[d - 1].l + words[d].l;
    take := true;
end;

procedure FindC(const d : integer);
begin
    if d > n then begin
        if words[0].l - stack[d - 1].l < lengthC then
            lengthC := words[0].l - stack[d - 1].l;
        Exit;
    end;
    stack[d] := stack[d - 1];
    FindC(d + 1);
    if take(d) then
        FindC(d + 1);
end;

procedure ProcessInput();
begin
    stack[0] := StrToTWord('');
    FindC(1);
end;

procedure WriteOutput();
begin
    Assign(outf, OUTPUT_FILE); Rewrite(outf);
    Writeln(outf, lengthC);
    Close(outf);
end;

begin
    lengthC := MAX_LENGTH + 1;
    ReadInput();
    ProcessInput();
    WriteOutput();
end.
