{ 2005-03-20 programmeerimisvistlus                                        }
{ lesanne: VOLDIK                                                          }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ Ebaige lahendus ahne algoritmiga }

const max = 500;
var s : array [1..max] of byte;

{ kontrollib, kas s[i1..i2] on murtav s[i] kohalt }
function murtav(i1, i2, i : integer) : boolean;
var j1, j2 : integer;
begin
   j1 := i; j2 := i;
   while (j1 > i1) and (j2 < i2) do begin
      j1 := j1 - 1; j2 := j2 + 1;
      if s[j1] = s[j2] then
         exit(false);
   end;
   exit(true);
end;

{ murrab alati ahnelt vimalikult pooleks }
function ahne(i1, i2 : integer) : integer;
var i : integer;
begin
   if i1 > i2 then
      exit(0);
   for i := (i2 - i1) div 2 downto 0 do begin
      if murtav(i1, i2, i1 + i) then
         exit(ahne(i1 + i + 1, i2) + 1);
      if murtav(i1, i2, i2 - i) then
         exit(ahne(i1, i2 - i - 1) + 1);
   end;
   writeln('AHNE'); halt(1); { siia ei jua kunagi }
end;

var f : text; i, n : integer;
begin
   assign(f, 'voldik.sis'); reset(f);
   readln(f, n);
   for i := 1 to n do
      read(f, s[i]);
   close(f);

   assign(f, 'voldik.val'); rewrite(f);
   writeln(f, ahne(1, n));
   close(f);
end.
