{ 2005-03-20 programmeerimisvistlus                                        }
{ lesanne: VOLDIK                                                          }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ ige ja efektiivne lahendus dnaamilise programmeerimisega }

const max = 500;
var s : array [1..max] of byte;

{ kontrollib, kas s[i1..i2] on murtav s[i] kohalt }
function murtav(i1, i2, i : integer) : boolean;
var j1, j2 : integer;
begin
   j1 := i; j2 := i;
   while (j1 > i1) and (j2 < i2) do begin
      j1 := j1 - 1; j2 := j2 + 1;
      if s[j1] = s[j2] then
         exit(false);
   end;
   exit(true);
end;

{ otsib parima lahenduse dnaamilise programmeerimisega }
function dp(n : integer) : integer;
var a : array [1..max, 1..max] of integer; { a[d+1, p] on s[p..p+d] voltimise hind }
var d, p, i, m, k : integer;
begin
   if n = 0 then
      exit(0);
   for p := 1 to n do
      a[1, p] := 1;
   for d := 1 to n - 1 do
      for p := 1 to n - d do begin
         m := d;
         for i := p to p + d do
            if murtav(p, p + d, i) then begin
               if i - p < (p + d) - i then
                  k := a[p + d - i, i + 1] { s[i+1..p+d] }
               else
                  k := a[i - p, p]; { s[p..i-1] }
               if m > k then
                  m := k;
            end;
         a[d + 1, p] := m + 1;
      end;
   exit(a[n, 1]);
end;

var f : text; i, n : integer;
begin
   assign(f, 'voldik.sis'); reset(f);
   readln(f, n);
   for i := 1 to n do
      read(f, s[i]);
   close(f);

   assign(f, 'voldik.val'); rewrite(f);
   writeln(f, dp(n));
   close(f);
end.
