const max = 500;
var s : array [1..max] of byte;

{ kontrollib, kas s[i1..i2] on murtav s[i] kohalt }
function murtav(i1, i2, i : integer) : boolean;
var j1, j2 : integer;
begin
   j1 := i; j2 := i;
   while (j1 > i1) and (j2 < i2) do begin
      j1 := j1 - 1; j2 := j2 + 1;
      if s[j1] = s[j2] then
         exit(false);
   end;
   exit(true);
end;

{ murrab alati ahnelt vimalikult pooleks }
function ahne(i1, i2 : integer) : integer;
var i : integer;
begin
   if i1 > i2 then
      exit(0);
   for i := (i2 - i1) div 2 downto 0 do begin
      if murtav(i1, i2, i1 + i) then
         exit(ahne(i1 + i + 1, i2) + 1);
      if murtav(i1, i2, i2 - i) then
         exit(ahne(i1, i2 - i - 1) + 1);
   end;
   writeln('AHNE'); halt(1); { siia ei jua kunagi }
end;

{ otsib parima lahenduse lbivaatusega }
function lv(i1, i2 : integer) : integer;
var i, m, k : integer;
begin
   if i1 > i2 then
      exit(0);
   m := i2 - i1;
   for i := i1 to i2 do
      if murtav(i1, i2, i) then begin
         if i - i1 < i2 - i then
            k := lv(i + 1, i2)
         else
            k := lv(i1, i - 1);
         if m > k then
            m := k;
      end;
   exit(m + 1);
end;

{ otsib parima lahenduse dnaamilise programmeerimisega }
function dp(n : integer) : integer;
var a : array [1..max, 1..max] of integer; { a[d+1, p] on s[p..p+d] voltimise hind }
var d, p, i, m, k : integer;
begin
   if n = 0 then
      exit(0);
   for p := 1 to n do
      a[1, p] := 1;
   for d := 1 to n - 1 do
      for p := 1 to n - d do begin
         m := d;
         for i := p to p + d do
            if murtav(p, p + d, i) then begin
               if i - p < (p + d) - i then
                  k := a[p + d - i, i + 1] { s[i+1..p+d] }
               else
                  k := a[i - p, p]; { s[p..i-1] }
               if m > k then
                  m := k;
            end;
         a[d + 1, p] := m + 1;
      end;
   exit(a[n, 1]);
end;

var n, k, i : integer;
begin
   readln(n);
   k := 0;
   repeat
      k := k + 1;
      writeln(stderr, k);
      for i := 1 to n do
         s[i] := random(1000) shr 3 and 1;
   until ahne(1, n) > dp(n);
   writeln(n);
   for i := 1 to n do
      if i < n then
         write(s[i], ' ')
      else
         writeln(s[i]);
end.
